
regret=zeros(S,5);

for n=1:S,
       
    tau=tau_addon(n)+tau_estimated;
    %tau=exp(tau_addon(n)+Z*theta_hat(KX+3:n_theta));
    mean_tau(n,:)=mean(tau);
    tau=tau.*(tau>0);

    for ns=1:NS,
                
        for h=1:Nr;
    
        X1=[X eita(:,h)];

        profit_k0=X1*theta_hat(1:(KX+1)); 
        normcdf_profit_k0=normcdf(profit_k0);
        A=match*normcdf_profit_k0;
        profit_k1=profit_k0+A*theta_hat(KX+2);
    
        profit=[profit_k0 profit_k1 zeros(N1,K-1)];

        fi(:,1)=tau.^(0)/factorial(0);
        fi_firm(:,K+1)=tau.^(K)/factorial(K);
        
            for k=2:K,
    
                fi(:,k)=tau.^(k-1)/factorial(k-1);
                sum_fi=fi*ones(k,k);
                f=fi./sum_fi;
  
                exptd_pr_rvls_k=normcdf(sum(profit(:,1:k).*f,2)); 
                A_k=match*exptd_pr_rvls_k;
                profit(:,k+1)=profit_k0+A_k*theta_hat(KX+2);    
                clear f exptd_pr_rvls_k A_k;

            end;

        fi_firm(:,1:K)=fi;
        clear fi;
        sum_fi_firm=fi_firm*ones(K+1,K+1);
        f_firm=fi_firm./sum_fi_firm;

        %  type=(K+1)*ones(N1,1);
        % for i=1:N1,
        %     while type(i)>K,
        %     type(i)=random('Poisson',tau(i));
        %     end;
        % 
        %     profit_tau_n(i,n)=profit(i,type(i)+1);
        % end;

        profit_tau_sim=sum(profit.*f_firm,2);  
        % this is the profit from an econometrian's point of view. a firm knows its true type.

        exante_profit_tau_sim(:,h,ns,n)=profit_tau_sim+epsilon(:,ns);
        entry_tau_sim(:,h,ns,n)=(exante_profit_tau_sim(:,h,ns,n)>=0);
        
        % find out whether increased entry results in more universal service: whether fewer markets will end up with no entrants.
        n_entrants(:,h,ns,n)=citymatch*citymatch'*entry_tau_sim(:,h,ns,n);
        entry_no_entrants_sim(:,h,ns,n)=(n_entrants(:,h,ns,n)==0);
        entry_one_entrants_sim(:,h,ns,n)=(n_entrants(:,h,ns,n)>=1).*(n_entrants(:,h,ns,n)<=4);
        entry_five_entrants_sim(:,h,ns,n)=(n_entrants(:,h,ns,n)>=5);

        %entry_four_entrants_sim(:,h,ns,n)=(n_entrants(:,h,ns,n)>=4).*(n_entrants(:,h,ns,n)<=6);
        %entry_seven_entrants_sim(:,h,ns,n)=(n_entrants(:,h,ns,n)>=7);

        A_k=match*entry_tau_sim(:,h,ns,n);
        expost_profit_tau_sim(:,h,ns,n)=profit_k0+A_k*theta_hat(KX+2)+epsilon(:,ns);

        expost_regret1_tau_sim(:,h,ns,n)=((exante_profit_tau_sim(:,h,ns,n)>=0).*(expost_profit_tau_sim(:,h,ns,n)<0)==1);
        expost_regret2_tau_sim(:,h,ns,n)=((exante_profit_tau_sim(:,h,ns,n)>=0)+(expost_profit_tau_sim(:,h,ns,n)<0)==0);
        expost_regret_tau_sim(:,h,ns,n)=expost_regret1_tau_sim(:,h,ns,n)+expost_regret2_tau_sim(:,h,ns,n);

        clear fi fi_firm f_firm profit;
        
        entry_tau_hnsn(h,ns,n)=mean(entry_tau_sim(:,h,ns,n),1);
        expost_regret1_tau_hnsn(h,ns,n)=mean(expost_regret1_tau_sim(:,h,ns,n),1);
        expost_regret2_tau_hnsn(h,ns,n)=mean(expost_regret2_tau_sim(:,h,ns,n),1);
        expost_regret_tau_hnsn(h,ns,n)=mean(expost_regret_tau_sim(:,h,ns,n),1);
        entry_no_entrants_hnsn(h,ns,n)=mean(entry_no_entrants_sim(:,h,ns,n),1);

        end;
        
        entry_tau_nsn(ns,n)=mean(entry_tau_hnsn(:,ns,n),1);
        expost_regret1_tau_nsn(ns,n)=mean(expost_regret1_tau_hnsn(:,ns,n),1);
        expost_regret2_tau_nsn(ns,n)=mean(expost_regret2_tau_hnsn(:,ns,n),1);
        expost_regret_tau_nsn(ns,n)=mean(expost_regret_tau_hnsn(:,ns,n),1);
        entry_no_entrants_nsn(ns,n)=mean(entry_no_entrants_hnsn(:,ns,n),1);
        
        entry_tau_overh(:,ns,n)=mean(entry_tau_sim(:,:,ns,n),2);
        zero_entrants_overh(:,ns,n)=mean(entry_no_entrants_sim(:,:,ns,n),2);
        one_entrants_overh(:,ns,n)=mean(entry_one_entrants_sim(:,:,ns,n),2);
        five_entrants_overh(:,ns,n)=mean(entry_five_entrants_sim(:,:,ns,n),2);
%         four_entrants_overh(:,ns,n)=mean(entry_four_entrants_sim(:,:,ns,n),2);
%         seven_entrants_overh(:,ns,n)=mean(entry_seven_entrants_sim(:,:,ns,n),2);
      
    end;
    
    entry_tau_n(n)=mean(entry_tau_nsn(:,n),1);
    expost_regret1_tau_n(n)=mean(expost_regret1_tau_nsn(:,n),1);%
    expost_regret2_tau_n(n)=mean(expost_regret2_tau_nsn(:,n),1);
    expost_regret_tau_n(n)=mean(expost_regret_tau_nsn(:,n),1);
    entry_no_entrants_n(n)=mean(entry_no_entrants_nsn(:,n),1);
     
    entry_tau_overns(:,n)=mean(entry_tau_overh(:,:,n),2);
    zero_entrants_overns(:,n)=mean(zero_entrants_overh(:,:,n),2);
    one_entrants_overns(:,n)=mean(one_entrants_overh(:,:,n),2);
    five_entrants_overns(:,n)=mean(five_entrants_overh(:,:,n),2);

%     four_entrants_overns(:,n)=mean(four_entrants_overh(:,:,n),2);
%     seven_entrants_overns(:,n)=mean(seven_entrants_overh(:,:,n),2);


regret(n,:)=[entry_tau_n(n) expost_regret1_tau_n(n) expost_regret2_tau_n(n) expost_regret_tau_n(n) entry_no_entrants_n(n)];

end;
